# Commands that run every game tick

# Boss triggers
execute @s[tag=!bossactive,tag=!bosscompleted] ~ ~ ~ execute @p[x=-193,y=124,z=-112,r=25,m=!c] ~ ~ ~ function boss/start
execute @s[tag=bossactive] ~ ~ ~ function boss/loop

execute @e[type=cf:shadow_orb,tag=!init] ~ ~ ~ function entity/shadow_orb/init
execute @e[type=cf:shadow_arm,tag=!init] ~ ~ ~ function entity/shadow_arm/init

execute @a[tag=shadowsword] ~ ~ ~ effect @s strength 1 5 true
execute @a[tag=shadowsword] ~ ~ ~ effect @s speed 1 1 true

execute @a[tag=crystalsword] ~ ~ ~ effect @s strength 1 5 true
execute @a[tag=crystalsword] ~ ~ ~ effect @s health_boost 1 3 true

# Whispering crystal triggers
execute @a[m=!c] ~ ~ ~ execute @e[tag=crystal,tag=!triggered,r=7] ~ ~ ~ function crystal/activate
execute @e[tag=crystal,tag=active] ~ ~ ~ function crystal/animate

# Trigger dialogue events
execute @s[tag=!trigdisembark] ~ ~ ~ execute @p[x=-100,y=115,z=199,dx=2,dy=4,dz=2,m=!c] ~ ~ ~ tag @e[tag=game] add trigdisembark
execute @s[tag=!trigcrewrelocate] ~ ~ ~ execute @p[x=-206,y=85,z=81,dx=8,dy=8,dz=8,m=!c] ~ ~ ~ tag @e[tag=game] add trigcrewrelocate
execute @s[tag=!trigef] ~ ~ ~ execute @p[x=-196,y=78,z=4,dx=6,dy=6,dz=4,m=!c] ~ ~ ~ tag @e[tag=game] add trigef

# Gravel pitfall
execute @s[tag=!graveltripped] ~ ~ ~ execute @p[x=-307,y=57,z=8,r=5,m=!c] ~ ~ ~ fill -298 55 16 -310 55 0 air 0 replace cobblestone
execute @s[tag=!graveltripped] ~ ~ ~ execute @p[x=-307,y=57,z=8,r=5,m=!c] ~ ~ ~ tag @e[tag=game] add graveltripped

# Crew relocation
execute @s[tag=trigcrewrelocate,tag=!crewrelocated] ~ ~ ~ execute @p ~ ~ ~ tag @e[tag=game] remove at_monument
execute @s[tag=trigcrewrelocate,tag=!crewrelocated] ~ ~ ~ execute @p[x=-193,y=71,z=41,r=70] ~ ~ ~ tag @e[tag=game] add at_monument
execute @s[tag=trigcrewrelocate,tag=!crewrelocated,tag=!at_monument] ~ ~ ~ function structure/relocate_crew

# Slime blocks give jump boost and slow falling
execute @a ~ ~ ~ detect ~ ~-1 ~ slime 0 effect @s jump_boost 1 15 false
execute @a ~ ~ ~ detect ~ ~-1 ~ slime 0 scoreboard players set @s falltimer 400
effect @a[scores={falltimer=1..}] slow_falling 1 1 false
scoreboard players remove @a[scores={falltimer=1..}] falltimer 1
